diff -uwrN sourceold/scripts/cPlayerKill.h source/scripts/cPlayerKill.h
--- sourceold/scripts/cPlayerKill.h	1970-01-01 10:00:00.000000000 +1000
+++ source/scripts/cPlayerKill.h	2017-01-22 19:51:12.959825900 +1000
@@ -0,0 +1,17 @@
+#ifndef TT_INCLUDE_CPLAYERKILL_H
+#define TT_INCLUDE_CPLAYERKILL_H
+#include "cNetEvent.h"
+
+class cPlayerKill : public cNetEvent {
+public:
+	int id1;
+	int id2;
+	cPlayerKill();
+	void Init(int player1, int player2);
+	virtual uint Get_Network_Class_ID() const;
+	virtual void Import_Creation(BitStreamClass& stream);
+	virtual void Export_Creation(BitStreamClass& stream);
+	virtual void Act();
+};
+
+#endif
\ No newline at end of file
diff -uwrN sourceold/scripts/cPurchaseResponseEvent.h source/scripts/cPurchaseResponseEvent.h
--- sourceold/scripts/cPurchaseResponseEvent.h	1970-01-01 10:00:00.000000000 +1000
+++ source/scripts/cPurchaseResponseEvent.h	2017-01-18 23:14:30.134112700 +1000
@@ -0,0 +1,41 @@
+/*	Renegade Scripts.dll
+Copyright 2013 Tiberian Technologies
+
+This file is part of the Renegade scripts.dll
+The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
+the terms of the GNU General Public License as published by the Free
+Software Foundation; either version 2, or (at your option) any later
+version. See the file COPYING for more details.
+In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
+Only the source code to the module(s) containing the licenced code has to be released.
+*/
+#ifndef TT_INCLUDE__CPURCHASERESPONSEEVENT_H
+#define TT_INCLUDE__CPURCHASERESPONSEEVENT_H
+
+#include "cNetEvent.h"
+
+
+class cPurchaseResponseEvent : public cNetEvent
+{
+
+private:
+
+   sint32 clientId;        // 1716
+   sint32 reply;           // 1720
+
+
+public:
+
+   cPurchaseResponseEvent();
+
+   virtual unsigned int Get_Network_Class_ID () const;
+   virtual void   Import_Creation      (BitStreamClass& oStream);
+   virtual void   Export_Creation      (BitStreamClass& oStream);
+   virtual void   Act                  ();
+
+   void Init (sint32 reply, sint32 clientId);
+
+};
+
+
+#endif
diff -uwrN sourceold/scripts/dllmain.cpp source/scripts/dllmain.cpp
--- sourceold/scripts/dllmain.cpp	2016-11-24 12:15:26.070870700 +1000
+++ source/scripts/dllmain.cpp	2017-01-18 23:09:21.418112700 +1000
@@ -273,6 +273,8 @@
 	Update_Network_Object_Player = (unop)Address(tt,"Update_Network_Object_Player");
 	Send_Client_Text = (sct)Address(tt,"Send_Client_Text");
 	Send_Client_Announcement = (sca)Address(tt,"Send_Client_Announcement");
+	Send_Player_Kill_Message = (spkm)Address(tt, "Send_Player_Kill_Message");
+	Send_Purchase_Response = (spr)Address(tt, "Send_Purchase_Response");
 	AddShaderNotify = (asn)Address(tt,"AddShaderNotify");
 	RemoveShaderNotify = (rsn)Address(tt,"RemoveShaderNotify");
 	Do_Objectives_Dlg = (dod)Address(tt,"Do_Objectives_Dlg");
@@ -363,6 +365,7 @@
 	Set_Background_Music_Player_Offset = (sbgmo)Address(tt,"Set_Background_Music_Player_Offset");
 	Set_Camera_Player = (setcam)Address(tt,"Set_Camera_Player");
 	Set_Definition_TranslationID_Player = (settran)Address(tt,"Set_Definition_TranslationID_Player");
+	Set_Net_Update_Rate_Player = (setnur)Address(tt,"Set_Net_Update_Rate_Player");
 
 #ifdef SSGM
 	SSGMGameManager::Init();
diff -uwrN sourceold/scripts/engine_tt.cpp source/scripts/engine_tt.cpp
--- sourceold/scripts/engine_tt.cpp	2016-11-24 12:15:26.071870700 +1000
+++ source/scripts/engine_tt.cpp	2017-01-18 23:09:21.413112700 +1000
@@ -132,6 +132,8 @@
 SCRIPTS_API unop Update_Network_Object_Player;
 SCRIPTS_API sct Send_Client_Text;
 SCRIPTS_API sca Send_Client_Announcement;
+SCRIPTS_API spkm Send_Player_Kill_Message;
+SCRIPTS_API spr Send_Purchase_Response;
 SCRIPTS_API dod Do_Objectives_Dlg;
 SCRIPTS_API sl Set_Player_Limit;
 SCRIPTS_API gl Get_Player_Limit;
@@ -213,6 +215,7 @@
 SCRIPTS_API sbgmo Set_Background_Music_Player_Offset;
 SCRIPTS_API setcam Set_Camera_Player;
 SCRIPTS_API settran Set_Definition_TranslationID_Player;
+SCRIPTS_API setnur Set_Net_Update_Rate_Player;
 
 SCRIPTS_API bool Can_Team_Build_Vehicle(int Team)
 {
diff -uwrN sourceold/scripts/engine_tt.h source/scripts/engine_tt.h
--- sourceold/scripts/engine_tt.h	2016-11-24 12:15:26.071870700 +1000
+++ source/scripts/engine_tt.h	2017-01-18 23:09:21.407112700 +1000
@@ -23,6 +23,8 @@
 class WideStringClass;
 class cScTextObj;
 class SCAnnouncement;
+class cPlayerKill;
+class cPurchaseResponseEvent;
 //start per-player script commands stuff
 typedef void (*_Enable_Stealth_Player) (GameObject *obj,GameObject *obj2,bool enable);
 typedef void (*_Set_Fog_Enable_Player) (GameObject *obj,bool enable);
@@ -139,6 +141,8 @@
 typedef void (*unop) (NetworkObjectClass *Object,int ID);
 typedef cScTextObj *(*sct) (const WideStringClass& message, TextMessageEnum type, bool popup, int senderId, int receiverId, bool dodirtybit, bool doact);
 typedef SCAnnouncement *(*sca) (int _receiptientId, int _senderId, int _translationId, AnnouncementEnum _type, int _emoticonId, bool dodirtybit, bool doact);
+typedef cPlayerKill *(*spkm) (int Killer, int Victim);
+typedef cPurchaseResponseEvent *(*spr) (int ID, int Type);
 typedef bool (*iwu) (wchar_t *WideName);
 typedef void (*cee) (const char *Explosion, Vector3 &Pos, GameObject *Creator);
 typedef void (*rwpa) (DynamicVectorClass<int> &WaypathIDs);
@@ -168,6 +172,7 @@
 typedef void (*sbgmo) (GameObject *obj,const char *music,float startoffset);
 typedef void (*setcam) (GameObject *obj,const char *camera);
 typedef void (*settran) (GameObject *obj,int defid,int stringid);
+typedef void (*setnur) (GameObject *obj,int rate);
 SCRIPTS_API extern gpl Get_Player_List;
 SCRIPTS_API extern gcmi Get_Current_Map_Index;
 SCRIPTS_API extern gm Get_Map;
@@ -272,6 +277,8 @@
 SCRIPTS_API extern unop Update_Network_Object_Player;
 SCRIPTS_API extern sct Send_Client_Text;
 SCRIPTS_API extern sca Send_Client_Announcement;
+SCRIPTS_API extern spkm Send_Player_Kill_Message;
+SCRIPTS_API extern spr Send_Purchase_Response;
 SCRIPTS_API extern dod Do_Objectives_Dlg;
 SCRIPTS_API extern sl Set_Player_Limit;
 SCRIPTS_API extern gl Get_Player_Limit;
@@ -339,6 +346,7 @@
 SCRIPTS_API extern sbgmo Set_Background_Music_Player_Offset;
 SCRIPTS_API extern setcam Set_Camera_Player;
 SCRIPTS_API extern settran Set_Definition_TranslationID_Player;
+SCRIPTS_API extern setnur Set_Net_Update_Rate_Player;
 
 class SCRIPTS_API JFW_Key_Hook_Base : public ScriptImpClass {
 public:
diff -uwrN sourceold/scripts/jfwweap.cpp source/scripts/jfwweap.cpp
--- sourceold/scripts/jfwweap.cpp	2016-10-31 07:17:12.525013500 +1000
+++ source/scripts/jfwweap.cpp	2017-01-18 17:52:28.777213800 +1000
@@ -1,4 +1,4 @@
-Renegade Scripts.dll
+/*  Renegade Scripts.dll
 	Copyright 2013 Tiberian Technologies
 
 	This file is part of the Renegade scripts.dll
diff -uwrN sourceold/scripts/jmgBearHunter.cpp source/scripts/jmgBearHunter.cpp
--- sourceold/scripts/jmgBearHunter.cpp	2016-12-14 05:47:13.345801000 +1000
+++ source/scripts/jmgBearHunter.cpp	2016-12-31 09:28:56.292000000 +1000
@@ -6683,6 +6683,18 @@
 	JMG_Wandering_AI_Controller::wanderPoints += node;
 	Commands->Destroy_Object(obj);
 }
+void JMG_Wandering_AI_Wander_Point_Dont_Remove::Created(GameObject *obj)
+{
+	if (!JMG_Wandering_AI_Controller::setup)
+	{
+		Console_Input("msg JMG_Wandering_AI_Wander_Point_Dont_Remove ERROR:: Make sure you have the script JMG_Wandering_AI_Controller placed on the map!");
+		Commands->Destroy_Object(obj);
+		return;
+	}
+	Rp2SimplePositionSystem::SimplePositionNode *node = new Rp2SimplePositionSystem::SimplePositionNode(obj);
+	node->value = Get_Int_Parameter("GroupId");
+	JMG_Wandering_AI_Controller::wanderPoints += node;
+}
 void JMG_Utility_Custom_Spawn_System_Controller::Destroyed(GameObject *obj)
 {
 	JMG_Utility_Custom_Spawn_System_Controller::setup = false;
@@ -7435,6 +7447,19 @@
 	*position = node->position;
 	return true;
 }
+bool JMG_Utility_AI_Guardian_Generic::Get_A_Defense_Point(Vector3 *position)
+{
+	Rp2SimplePositionSystem::SimplePositionNode *node = NULL;
+	if (Get_Int_Parameter("WanderingAIGroupID") != -1)
+		node = JMG_Wandering_AI_Controller::wanderPoints.GetRandomFromGroup(Get_Int_Parameter("WanderingAIGroupID"));
+	if (!node)
+	{
+		Console_Input("msg JMG_Utility_AI_Guardian_Generic ERROR: No wander points could be found for that group!");
+		return false;
+	}
+	*position = node->position;
+	return true;
+}
 bool JMG_Utility_Zone_Teleport_To_Random_Wander_Point::Get_A_Defense_Point(Vector3 *position,float *facing)
 {
 	Rp2SimplePositionSystem::SimplePositionNode *node = NULL;
@@ -7706,6 +7731,7 @@
 ScriptRegistrant<JMG_Wandering_AI> JMG_Wandering_AI_Registrant("JMG_Wandering_AI","GroupID=-1:int,Wander_Speed=1.0:float,Normal_Range=3.0:float,Vehicle_Range=12.5:float,Attack_Move_Range=1.4:float");
 ScriptRegistrant<JMG_Wandering_AI_Controller> JMG_Wandering_AI_Controller_Registrant("JMG_Wandering_AI_Controller","");
 ScriptRegistrant<JMG_Wandering_AI_Wander_Point> JMG_Wandering_AI_Wander_Point_Registrant("JMG_Wandering_AI_Wander_Point","GroupId:int");
+ScriptRegistrant<JMG_Wandering_AI_Wander_Point_Dont_Remove> JMG_Wandering_AI_Wander_Point_Dont_Remove_Registrant("JMG_Wandering_AI_Wander_Point_Dont_Remove","GroupId:int");
 ScriptRegistrant<JMG_Utility_Custom_Spawn_System_Controller> JMG_Utility_Custom_Spawn_System_Controller_Registrant("JMG_Utility_Custom_Spawn_System_Controller","");
 ScriptRegistrant<JMG_Utility_Custom_Spawn_System_Point> JMG_Utility_Custom_Spawn_System_Point_Registrant("JMG_Utility_Custom_Spawn_System_Point","GroupId:int");
 ScriptRegistrant<JMG_Utility_Custom_Spawn_System> JMG_Utility_Custom_Spawn_System_Registrant("JMG_Utility_Custom_Spawn_System","Spawn_Point_Group=-1:int,Max_Spawned_At_Once=1:int,Spawn_Limit=-1:int,Respawn_Delay=10.0:float,Random_Delay=0.0:float,Delay_First_Spawn=0:int,Starts_Enabled=1:int,Enable_Message=403401,Disable_Message=403400,Preset0=null:string,Preset1=null:string,Preset2=null:string,Preset3=null:String,Preset4=null:string,Preset5=null:string,Preset6=null:string,Preset7=null:string,Preset8=null:string,Preset9=null:string,Chance0=0:int,Chance1=0:int,Chance2=0:int,Chance3=0:int,Chance4=0:int,Chance5=0:int,Chance6=0:int,Chance7=0:int,Chance8=0:int,Chance9=0:int");
diff -uwrN sourceold/scripts/jmgBearHunter.h source/scripts/jmgBearHunter.h
--- sourceold/scripts/jmgBearHunter.h	2016-10-31 07:17:12.533013500 +1000
+++ source/scripts/jmgBearHunter.h	2016-12-31 09:28:56.294000000 +1000
@@ -3146,6 +3146,9 @@
 class JMG_Wandering_AI_Wander_Point : public ScriptImpClass {
 	void Created(GameObject *obj);
 };
+class JMG_Wandering_AI_Wander_Point_Dont_Remove : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
 class JMG_Utility_Custom_Spawn_System_Controller : public ScriptImpClass {
 	void Destroyed(GameObject *obj);
 public:
diff -uwrN sourceold/scripts/jmgUtility.cpp source/scripts/jmgUtility.cpp
--- sourceold/scripts/jmgUtility.cpp	2016-12-17 21:07:23.265015700 +1000
+++ source/scripts/jmgUtility.cpp	2017-01-22 19:51:59.210626000 +1000
@@ -458,7 +458,7 @@
 }
 void JMG_Utility_Basic_Spawner::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
-	if (Get_Int_Parameter("EnableCustom") && message == Get_Int_Parameter("EnableCustom"))
+	if (Get_Int_Parameter("EnableOrDisableCustom") && message == Get_Int_Parameter("EnableOrDisableCustom"))
 	{
 		if (param == 1)
 		{
@@ -876,7 +876,14 @@
 		Commands->Enable_Hibernation(obj,false);
 	}
 	Commands->Start_Timer(obj,this,1.0,1);
+	grabNextPointDistance = Get_Float_Parameter("NextWanderPointWhenLastReached")*Get_Float_Parameter("NextWanderPointWhenLastReached");
 	if (Get_Int_Parameter("WanderingAIGroupID") != -1)
+		if (grabNextPointDistance)
+		{
+			lastWanderPointSpot = Commands->Get_Position(obj);
+			Commands->Start_Timer(obj,this,0.1f,9);
+		}
+		else
 		Commands->Start_Timer(obj,this,Get_Float_Parameter("MinRandWander") == Get_Float_Parameter("MaxRandWander") ? Get_Float_Parameter("MaxRandWander") : Commands->Get_Random(Get_Float_Parameter("MinRandWander"),Get_Float_Parameter("MaxRandWander")),2);
 	Commands->Start_Timer(obj,this,5.0,3);
 	Commands->Start_Timer(obj,this,0.1f,8);
@@ -923,6 +930,8 @@
 {
 	if (damage <= 0 || Commands->Get_Player_Type(damager) == Commands->Get_Player_Type(obj))
 		return;
+	if (Is_Script_Attached(damager,"JMG_Utility_AI_Vehicle_Ignored"))
+		return;
 	if (!_stricmp(Get_Skin(damager),"Blamo") || !_stricmp(Get_Shield_Type(damager),"Blamo"))
 		return;
 	if(!attacking)
@@ -933,6 +942,8 @@
 }
 void JMG_Utility_AI_Vehicle::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (Is_Script_Attached(seen,"JMG_Utility_AI_Vehicle_Ignored"))
+		return;
 	Vector3 enemyPos = Commands->Get_Position(seen);
 	float dist = JmgUtility::SimpleDistance(Commands->Get_Position(obj),enemyPos);
 	if (!_stricmp(Get_Skin(seen),"Blamo") || !_stricmp(Get_Shield_Type(seen),"Blamo"))
@@ -1060,6 +1071,19 @@
 		}
 		Commands->Start_Timer(obj,this,0.1f,8);
 	}
+	if (number == 9)
+	{
+		if (!Get_Int_Parameter("FollowTarget") || !currentAction.targetId)
+		{
+			if (JmgUtility::SimpleDistance(Commands->Get_Position(obj),lastWanderPointSpot) <= grabNextPointDistance)
+			{
+				GetRandomPosition(&lastWanderPointSpot);
+				moving = true;
+			}
+			AttackMove(obj,Commands->Find_Object(currentAction.targetId),false,lastWanderPointSpot,currentAction.useAmmo,0.0f,false,2.5f);
+		}
+		Commands->Start_Timer(obj,this,1.0f,9);
+	}
 }
 void JMG_Utility_AI_Vehicle::ReturnHome(GameObject * obj)
 {
@@ -1219,11 +1243,6 @@
 }
 void JMG_Utility_AI_Vehicle::StuckCheck(GameObject *obj)
 {
-	if (!moving)
-	{
-		drivingBackward= false;
-		return;
-	}
 	Vector3 current = Commands->Get_Position(obj);
 	if (reverseTime)
 	{
@@ -1231,14 +1250,19 @@
 		stuckCount = 0;
 		mypos = current;
 		drivingBackward = false;
-		AttackMove(obj,Commands->Find_Object(lastAction.targetId),lastAction.following,lastAction.position,lastAction.useAmmo,0.0f,true,currentAction.arriveDistance);
+		AttackMove(obj,Commands->Find_Object(lastAction.targetId),lastAction.following,lastAction.position,lastAction.useAmmo,0.0f,true,0.0f);
+		return;
+	}
+	if (!moving)
+	{
+		drivingBackward = false;
 		return;
 	}
 	if(JmgUtility::SimpleDistance(mypos,current) < 1.0f)
 	{
 		if(stuckCount > 2)
 		{
-			reverseTime = Commands->Get_Random_Int(1,6);
+			reverseTime = Commands->Get_Random_Int(2,6);
 			stuckCount = 0;
 			drivingBackward = true;
 			AttackMove(obj,Commands->Find_Object(lastAction.targetId),lastAction.following,lastAction.position,lastAction.useAmmo,0.0f,true,currentAction.arriveDistance);
@@ -1260,9 +1284,9 @@
 			dist = JmgUtility::SimpleDistance(Commands->Get_Position(target),mypos);
 		else
 			dist = JmgUtility::SimpleDistance(currentAction.position,mypos);
-	if (dist > minDistanceSquared+1089.0f)
+	if (minDistanceSquared && dist > minDistanceSquared+1089.0f)
 		retreatPos = mypos;
-	if (dist < minDistanceSquared && !(Get_Int_Parameter("SquishInfantry") && target->As_SoldierGameObj()))
+	if (minDistanceSquared && dist < minDistanceSquared && !(Get_Int_Parameter("SquishInfantry") && target->As_SoldierGameObj()))
 	{
 		if (retreatTime)
 			return;
@@ -1285,7 +1309,6 @@
 	Commands->Action_Reset(obj,10.0f);
 	moving = isMoving;
 	ActionParamsStruct params;
-	params.Set_Basic(this,10,10);
 	if (target)
 	{
 		JMGVehicleAmmo ammo = (fireMode ? primary : secondary);
@@ -1302,7 +1325,6 @@
 		}
 		if (Get_Int_Parameter("SquishInfantry") && target->As_SoldierGameObj() && !Is_Unsquishable(target))
 			canSquish = true;
-		Commands->Action_Attack(obj,params);
 	}
 	if (followTarget)
 		if (Is_VTOL(obj) && Get_Float_Parameter("VTOLHover") && !canSquish)
@@ -1333,10 +1355,15 @@
 			params.ShutdownEngineOnArrival = true;
 		params.MovePathfind = !doNotUsePathfind && Get_Int_Parameter("UsePathfind") ? true : false;
 	}
+	if (!target)
+		params.Set_Basic(this,10,10);
 	Commands->Action_Goto(obj,params);
 	if (target)
+	{
+		params.Set_Basic(this,10,10);
 		Commands->Action_Attack(obj,params);
 }
+}
 JMG_Utility_AI_Vehicle::JMGVehicleAmmo JMG_Utility_AI_Vehicle::DefineAmmo(const AmmoDefinitionClass *ammo)
 {
 	JMGVehicleAmmo theammo;
@@ -1756,10 +1783,12 @@
 void JMG_Utility_Display_Text_Message_To_All_Players_On_Custom::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
 	if (message == Get_Int_Parameter("Custom"))
+	{
 		JmgUtility::MessageAllPlayers((int)Get_Vector3_Parameter("ColorRGB").X,(int)Get_Vector3_Parameter("ColorRGB").Y,(int)Get_Vector3_Parameter("ColorRGB").Z,Get_Parameter("Message"));
 	if (!Get_Int_Parameter("Repeatable"))
 		Destroy_Script();
 }
+}
 void JMG_Utility_Set_Team_On_Create::Created(GameObject *obj)
 {
 	if (!Get_Float_Parameter("Delay"))
@@ -2444,6 +2473,8 @@
 }
 void JMG_Utility_AI_Guardian_Aircraft::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (Is_Script_Attached(seen,"JMG_Utility_AI_Guardian_Ignored"))
+		return;
 	if (!EnemyID || !EnemyTimeOutTime)
 	{
 		EnemyID = Commands->Get_ID(seen);
@@ -2966,6 +2997,8 @@
 		if (objectId)
 		{
 			GameObject *point = Commands->Find_Object(objectId);
+			if (!point)
+				Console_Input("msg JMG_Utility_AI_Aggressive_Attack_Spot_Point2 ERROR: Could not find the ObjectID specified!");
 			attackSpot = Commands->Get_Position(point);
 			Commands->Destroy_Object(point);
 		}
@@ -2989,7 +3022,8 @@
 	lastSeenTime = 0;
 	stuckTime = 0;
 	reverseTime = 0;
-	const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(Get_Current_Weapon(obj),true);
+	usePrimaryFire = Get_Int_Parameter("UseSecondaryFire") ? false : true;
+	const AmmoDefinitionClass *ammo = Get_Weapon_Ammo_Definition(Get_Current_Weapon(obj),usePrimaryFire);
 	if (ammo)
 	{
 		weaponRange = ammo->Range;
@@ -3149,14 +3183,14 @@
 		location.X += attackNode->attackOffset.X;
 		location.Y += attackNode->attackOffset.Y;
 		location.Z += attackNode->attackOffset.Z;
-		params.Set_Attack(location,weaponRange,0.0f,true);
+		params.Set_Attack(location,weaponRange,0.0f,usePrimaryFire);
 		params.AttackLocation = location;
 		params.AttackCheckBlocked = false;
 		Commands->Action_Attack(obj,params);
 	}
 	else if (target && attack)
 	{
-		params.Set_Attack(target,weaponRange,0.0f,true);
+		params.Set_Attack(target,weaponRange,0.0f,usePrimaryFire);
 		Commands->Action_Attack(obj,params);
 	}
 }
@@ -3441,7 +3475,7 @@
 	controllerPlaced = true;
 	for (int x = 0;x < 128;x++)
 		playerNames[x][0] = '\0';
-	BasicObjectiveSystem = NewObjectiveSystem(2,Get_Int_Parameter("ShowMarkersOnRadar") ? true : false,Get_Parameter("PrimaryObjectiveModel"),Get_Parameter("SecondaryObjectiveModel"),Get_Parameter("TertiaryObjectiveModel"));
+	BasicObjectiveSystem = NewObjectiveSystem(Get_Int_Parameter("Team"),Get_Int_Parameter("ShowMarkersOnRadar") ? true : false,Get_Parameter("PrimaryObjectiveModel"),Get_Parameter("SecondaryObjectiveModel"),Get_Parameter("TertiaryObjectiveModel"));
 	Commands->Start_Timer(obj,this,1.0f,1);
 }
 void JMG_Utility_Objective_System_Controller::Timer_Expired(GameObject *obj,int number)
@@ -3882,6 +3916,8 @@
 }
 void JMG_Utility_AI_Guardian_Infantry::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (Is_Script_Attached(seen,"JMG_Utility_AI_Guardian_Ignored"))
+		return;
 	if (!EnemyID || !EnemyTimeOutTime)
 	{
 		EnemyID = Commands->Get_ID(seen);
@@ -4265,6 +4301,8 @@
 	GameObject *object = id ? (id == -1 ? enter : Commands->Find_Object(id)) : obj;
 	if (object)
 		Commands->Send_Custom_Event(obj,object,Get_Int_Parameter("Custom"),Get_Int_Parameter("Param"),Get_Float_Parameter("Delay"));
+	if (Get_Int_Parameter("RemoveWeapon"))
+		Remove_Weapon(enter,Get_Parameter("WeaponName"));
 	if (Get_Int_Parameter("TriggerOnce"))
 		Destroy_Script();
 }
@@ -4615,6 +4653,7 @@
 }
 void JMG_Utility_Custom_Display_Briefing_Message::Created(GameObject *obj)
 {
+	triggered = false;
 	BriefingText = NULL;
 	CurrentNode = NULL;
 	int File = Commands->Text_File_Open(Get_Parameter("FileName"));
@@ -4638,7 +4677,7 @@
 			int Count = 0;
 			for (int x = 0;x < 16384;x++)
 			{
-				if ((Count > 150 && TextString[x] == ' ') || Count == 220)
+				if ((Count > 150 && TextString[x] == ' ') || Count == 210)
 				{// String getting too long, start a new one.
 					CurrentNode->Text[Count] = '\0';
 					AddNewTextNode();
@@ -4699,6 +4738,9 @@
 {
 	if (message == Get_Int_Parameter("Custom"))
 	{
+		if (triggered)
+			return;
+		triggered = true;
 		Commands->Start_Timer(obj,this,0.0f,56345344);
 		Commands->Create_2D_Sound(Get_Parameter("UISound"));
 	}
@@ -5181,6 +5223,8 @@
 }
 GameObject *JMG_Utility_AI_Goto_Enemy::findClosestStar(GameObject *obj)
 {
+	if (Commands->Get_Player_Type(obj) == -2)
+		return NULL;
 	GameObject *nearest = NULL;
 	float nearDist = -1.0f;
 	Vector3 pos = Commands->Get_Position(obj);
@@ -5504,6 +5548,8 @@
 }
 GameObject *JMG_Utility_AI_Goto_Enemy_Not_Star::findClosestStar(GameObject *obj)
 {
+	if (Commands->Get_Player_Type(obj) == -2)
+		return NULL;
 	GameObject *nearest = NULL;
 	float nearDist = -1.0f;
 	Vector3 pos = Commands->Get_Position(obj);
@@ -5771,6 +5817,8 @@
 }
 void JMG_Utility_AI_Guardian_Vehicle::Enemy_Seen(GameObject *obj,GameObject *seen)
 {
+	if (Is_Script_Attached(seen,"JMG_Utility_AI_Guardian_Ignored"))
+		return;
 	if (!EnemyID || !EnemyTimeOutTime)
 	{
 		EnemyID = Commands->Get_ID(seen);
@@ -5867,8 +5915,14 @@
 char JMG_Utility_Send_Custom_On_Deaths_Controller::remainingPlural[220] = "";
 int JMG_Utility_Send_Custom_On_Deaths_Controller::reminderMessageOrder = 0;
 int JMG_Utility_Send_Custom_On_Deaths_Controller::myId = 0;
+bool JMG_Utility_Send_Custom_On_Deaths_Controller::controllerPlaced = false;
 void JMG_Utility_Send_Custom_On_Deaths_Controller::Created(GameObject *obj)
 {
+	if (controllerPlaced)
+	{
+		Console_Input("msg JMG_Utility_Send_Custom_On_Deaths_Controller ERROR: Only place one controller on the map at a time!");
+		return;
+	}
 	deathCount = 0;
 	maxDeaths = Get_Int_Parameter("MaxDeaths");
 	deathReminder = Get_Int_Parameter("DeathReminder");
@@ -5887,8 +5941,13 @@
 	sprintf(deathPlural,"%s",Get_Parameter("DeathPlural"));
 	sprintf(remainingSingular,"%s",Get_Parameter("RemainingSingular"));
 	sprintf(remainingPlural,"%s",Get_Parameter("RemainingPlural"));
+	controllerPlaced = true;
 	myId = Commands->Get_ID(obj);
 }
+void JMG_Utility_Send_Custom_On_Deaths_Controller::Destroyed(GameObject *obj)
+{
+	controllerPlaced = false;
+}
 void JMG_Utility_Send_Custom_On_Deaths_Controller::Custom(GameObject *obj,int message,int param,GameObject *sender)
 {
 	if (message == 8765432 && param == 8765432)
@@ -5908,6 +5967,8 @@
 }
 void JMG_Utility_Send_Custom_On_Deaths_Reporter::Killed(GameObject *obj,GameObject *killer)
 {
+	if (!JMG_Utility_Send_Custom_On_Deaths_Controller::controllerPlaced)
+		return;
 	JMG_Utility_Send_Custom_On_Deaths_Controller::deathCount++;
 	int deathCount = JMG_Utility_Send_Custom_On_Deaths_Controller::deathCount;
 	int remainingLives = JMG_Utility_Send_Custom_On_Deaths_Controller::maxDeaths-JMG_Utility_Send_Custom_On_Deaths_Controller::deathCount;
@@ -6476,7 +6537,7 @@
 void JMG_Utility_Player_Count_Enable_Spawners::Created(GameObject *obj)
 {
 	enabled = Get_Int_Parameter("StartsEnabled") ? true : false;
-	enableCustom = Get_Int_Parameter("EnableCustom");
+	enableCustom = Get_Int_Parameter("EnableOrDisableCustom");
 	playerCount = Get_Vector3_Parameter("PlayerCount[eq|<|>]");
 	playerCount2 = Get_Vector3_Parameter("PlayerCount[neq|between(|)]");
 	conditionMatching = false;
@@ -6533,7 +6594,7 @@
 		location = Commands->Get_Position(obj);
 	range = Get_Float_Parameter("Range");
 	range *= range;
-	enableCustom = Get_Int_Parameter("EnableCustom");
+	enableCustom = Get_Int_Parameter("EnableOrDisableCustom");
 	enabled = Get_Int_Parameter("StartsEnabled") ? true : false;
 	selectWeapon = Get_Int_Parameter("SelectWeapon") ? true : false;
 	weaponAmmo = Get_Int_Parameter("WeaponAmmo");
@@ -6655,6 +6716,9 @@
 	messageFollowerLostId = Get_Int_Parameter("MessageFollowerLostID");
 	messageFollowerInjuredId = Get_Int_Parameter("MessageFollowerInjuredID");
 	messageFollowerKilledId = Get_Int_Parameter("MessageFollowerKilledID");
+	lastPos = Commands->Get_Position(obj);
+	maxFollowTime = Get_Int_Parameter("MaxFollowTime");
+	maxIdleTime = Get_Int_Parameter("MaxIdleTime");
 	Commands->Start_Timer(obj,this,0.1f,1);
 	Commands->Enable_Enemy_Seen(obj,true);
 	Commands->Enable_HUD_Pokable_Indicator(obj,true);
@@ -6677,7 +6741,7 @@
 {
 	if (number == 1)
 	{
-		float speed = followNearSpeed;
+		float speed = runHomeSpeed;
 		float distance = followDistance;
 		Vector3 myPos = Commands->Get_Position(obj);
 		if (enemySeen)
@@ -6694,12 +6758,38 @@
 		else if (enemyId)
 			ForgetEnemy(obj);
 		GameObject *player = Commands->Find_Object(playerObjectId);
+		if (player)
+		{
+			bool quitFollowing = false;
+			if (maxFollowTime)
+			{
+				currentFollowTime++;
+				if (currentFollowTime == maxFollowTime)
+					quitFollowing = true;
+			}
+			if (maxIdleTime && JmgUtility::SimpleDistance(myPos,lastPos) <= 0.0f)
+			{
+				currentIdleTime++;
+				if (currentIdleTime == maxIdleTime)
+					quitFollowing = true;
+			}
+			else
+				currentIdleTime = 0;
+			if (quitFollowing)
+			{
+				ShowPlayerMessage(player,messageFollowerLostId,messageColor);
+				SendCustom(obj,lostCustom);
+				GiveUpOnPlayer(obj,true);
+				player = NULL;
+			}
+			lastPos = myPos;
+		}
 		if (pokerPlayerId && !player)
 		{
 			SendCustom(obj,lostCustom);
 			GiveUpOnPlayer(obj,true);
 		}
-		else
+		else if (player)
 		{
 			float tempDist = JmgUtility::SimpleDistance(Commands->Get_Position(player),myPos);
 			if (tempDist >= followVeryFarDistance)
@@ -6709,15 +6799,15 @@
 			else
 				speed = followNearSpeed;
 		}
-		if (hurt)
+		if (hurt || !player)
 		{
 			distance = 1.0f;
 			speed = runHomeSpeed;
 		}
-		if (hurt && healWhileAtHomeLocation && Commands->Get_Shield_Strength(obj) < Commands->Get_Max_Shield_Strength(obj) && JmgUtility::SimpleDistance(myPos,homeLocation) <= 2.0f)
+		if (healWhileAtHomeLocation && Commands->Get_Shield_Strength(obj) < Commands->Get_Max_Shield_Strength(obj) && JmgUtility::SimpleDistance(myPos,homeLocation) <= 2.0f)
 		{
 			Commands->Apply_Damage(obj,-healWhileAtHomeLocation,"None",0);
-			if (!pokerPlayerId && fallbackWithoutArmor && Commands->Get_Shield_Strength(obj) >= Commands->Get_Max_Shield_Strength(obj))
+			if (hurt && !pokerPlayerId && fallbackWithoutArmor && Commands->Get_Shield_Strength(obj) >= Commands->Get_Max_Shield_Strength(obj))
 			{
 				Commands->Enable_HUD_Pokable_Indicator(obj,true);
 				SendCustom(obj,healedCustom);
@@ -6788,6 +6878,8 @@
 		ShowPlayerMessage(poker,messageHealingRequiredId,messageColor);
 		return;
 	}
+	currentFollowTime = 0;
+	currentIdleTime = 0;
 	SendCustom(obj,pokedCustom);
 	pokerPlayerId = playerId;
 	playerObjectId = Commands->Get_ID(poker);
@@ -6834,7 +6926,7 @@
 {
 	if (!custom)
 		return;
-	GameObject *controller = Commands->Find_Object(sendCustomId);
+	GameObject *controller = sendCustomId ? Commands->Find_Object(sendCustomId) : obj;
 	if (controller)
 		Commands->Send_Custom_Event(obj,controller,custom,0,0);
 }
@@ -6934,13 +7026,13 @@
 	leavingFieldStringId = Get_Int_Parameter("Warning_StringID");
 	errorMessageColor = Get_Vector3_Parameter("Warning_Color");
 	screenFadeColor = Get_Vector3_Parameter("Screen_Fade_Color");
-	myPos = Commands->Get_Position(obj);
 	Commands->Start_Timer(obj,this,0.1f,1);
 }
 void JMG_Utility_Damage_When_Outside_Of_Range::Timer_Expired(GameObject *obj, int number)
 {
 	if (number == 1)
 	{
+		Vector3 myPos = Commands->Get_Position(obj);
 		for (int x = 1;x < 128;x++)
 		{
 			if (warnTime[x])
@@ -6956,14 +7048,15 @@
 				{
 					screenEffectOn[x] = true;
 					float TempDistCalc = 1-(dist-maxSurviveDistance)/(warnDistance-maxSurviveDistance);
-					Set_Screen_Fade_Color_Player(player,screenFadeColor.X,screenFadeColor.Y,screenFadeColor.Z,0.1f);
-					Set_Screen_Fade_Opacity_Player(player,TempDistCalc,0.1f);
+					float inverted = 1-TempDistCalc;
+					Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X*inverted+screenFadeColor.X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y*inverted+screenFadeColor.Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z*inverted+screenFadeColor.Z,0.1f);
+					Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x]*inverted+TempDistCalc,0.1f);
 				}
 				else if (screenEffectOn[x])
 				{
 					screenEffectOn[x] = false;
-					Set_Screen_Fade_Color_Player(player,0.0f,0.0f,0.0f,0.1f);
-					Set_Screen_Fade_Opacity_Player(player,0.0f,0.1f);
+					Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z,0.1f);
+					Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x],0.1f);
 				}
 				if (dist >= warnDistance && !warnTime[x])
 				{
@@ -6981,14 +7074,15 @@
 					{
 						screenEffectOn[x] = true;
 						float TempDistCalc = 1-(dist-maxSurviveDistance)/(aircraftWarnDistance-maxSurviveDistance);
-						Set_Screen_Fade_Color_Player(player,screenFadeColor.X,screenFadeColor.Y,screenFadeColor.Z,0.1f);
-						Set_Screen_Fade_Opacity_Player(player,TempDistCalc,0.1f);
+						float inverted = 1-TempDistCalc;
+						Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X*inverted+screenFadeColor.X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y*inverted+screenFadeColor.Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z*inverted+screenFadeColor.Z,0.1f);
+						Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x]*inverted+TempDistCalc,0.1f);
 					}
 					else if (screenEffectOn[x])
 					{
 						screenEffectOn[x] = false;
-						Set_Screen_Fade_Color_Player(player,0.0f,0.0f,0.0f,0.1f);
-						Set_Screen_Fade_Opacity_Player(player,0.0f,0.1f);
+						Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z,0.1f);
+						Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x],0.1f);
 					}
 					if (dist >= aircraftWarnDistance && !warnTime[x])
 					{
@@ -7002,14 +7096,15 @@
 					{
 						screenEffectOn[x] = true;
 						float TempDistCalc = 1-(dist-maxSurviveDistance)/(vehicleWarnDistance-maxSurviveDistance);
-						Set_Screen_Fade_Color_Player(player,screenFadeColor.X,screenFadeColor.Y,screenFadeColor.Z,0.1f);
-						Set_Screen_Fade_Opacity_Player(player,TempDistCalc,0.1f);
+						float inverted = 1-TempDistCalc;
+						Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X*inverted+screenFadeColor.X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y*inverted+screenFadeColor.Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z*inverted+screenFadeColor.Z,0.1f);
+						Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x]*inverted+TempDistCalc,0.1f);
 					}
 					else if (screenEffectOn[x])
 					{
 						screenEffectOn[x] = false;
-						Set_Screen_Fade_Color_Player(player,0.0f,0.0f,0.0f,0.1f);
-						Set_Screen_Fade_Opacity_Player(player,0.0f,0.1f);
+						Set_Screen_Fade_Color_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].X,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Y,JMG_Utility_Set_Screen_Color_Fade_Controller::color[x].Z,0.1f);
+						Set_Screen_Fade_Opacity_Player(player,JMG_Utility_Set_Screen_Color_Fade_Controller::opacity[x],0.1f);
 					}
 					if (dist >= vehicleWarnDistance && !warnTime[x])
 					{
